#include <QGuiApplication>
#include <QQmlApplicationEngine>
#include <iostream>
#include <string>

#include "oboy.h"
#include "oimageprovider.h"

#include <caml/callback.h>

int main(int argc, char *argv[])
{
    QCoreApplication::setApplicationName("OBoy");
    QCoreApplication::setOrganizationName("ffreling");
    QCoreApplication::setOrganizationDomain("ffreling.com");
    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
    QGuiApplication app(argc, argv);

    caml_main(argv);

    qmlRegisterType<OBoy>("com.oboy.oboy", 1, 0, "OBoy");

    QQmlApplicationEngine engine;
    engine.addImageProvider(QLatin1String("oboy"), new OImageProvider(engine));
    engine.load(QUrl(QStringLiteral("qrc:/main.qml")));

    return app.exec();
}
